Loading...
Searching...
No Matches
pcl::registration::CorrespondenceRejector Class Referenceabstract
Module registration

CorrespondenceRejector represents the base class for correspondence rejection methods More...

`#include <pcl/registration/correspondence_rejection.h>`

Inheritance diagram for pcl::registration::CorrespondenceRejector:

## Public Types

using | Ptr = shared_ptr<CorrespondenceRejector>
using | ConstPtr = shared_ptr<const CorrespondenceRejector>

## Public Member Functions

| CorrespondenceRejector ()=default
| Empty constructor.
virtual | ~CorrespondenceRejector ()=default
| Empty destructor.
virtual void | setInputCorrespondences (const CorrespondencesConstPtr &correspondences)
| Provide a pointer to the vector of the input correspondences.
CorrespondencesConstPtr | getInputCorrespondences ()
| Get a pointer to the vector of the input correspondences.
void | getCorrespondences (pcl::Correspondences &correspondences)
| Run correspondence rejection.
virtual void | getRemainingCorrespondences (const pcl::Correspondences &original_correspondences, pcl::Correspondences &remaining_correspondences)=0
| Get a list of valid correspondences after rejection from the original set of correspondences.
void | getRejectedQueryIndices (const pcl::Correspondences &correspondences, pcl::Indices &indices)
| Determine the indices of query points of correspondences that have been rejected, i.e., the difference between the input correspondences (set via setInputCorrespondences) and the given correspondence vector.
const std::string & | getClassName () const
| Get a string representation of the name of this class.
virtual bool | requiresSourcePoints () const
| See if this rejector requires source points.
virtual void | setSourcePoints (pcl::PCLPointCloud2::ConstPtr)
| Abstract method for setting the source cloud.
virtual bool | requiresSourceNormals () const
| See if this rejector requires source normals.
virtual void | setSourceNormals (pcl::PCLPointCloud2::ConstPtr)
| Abstract method for setting the source normals.
virtual bool | requiresTargetPoints () const
| See if this rejector requires a target cloud.
virtual void | setTargetPoints (pcl::PCLPointCloud2::ConstPtr)
| Abstract method for setting the target cloud.
virtual bool | requiresTargetNormals () const
| See if this rejector requires target normals.
virtual void | setTargetNormals (pcl::PCLPointCloud2::ConstPtr)
| Abstract method for setting the target normals.

## Protected Member Functions

virtual void | applyRejection (Correspondences &correspondences)=0
| Abstract rejection method.

## Protected Attributes

std::string | rejection_name_ {}
| The name of the rejection method.
CorrespondencesConstPtr | input_correspondences_
| The input correspondences.

## Detailed Description

CorrespondenceRejector represents the base class for correspondence rejection methods

Author
  Dirk Holz

Definition at line 54 of file correspondence_rejection.h.

## Member Typedef Documentation

## ConstPtr

using pcl::registration::CorrespondenceRejector::ConstPtr = shared_ptr<const CorrespondenceRejector>

Definition at line 57 of file correspondence_rejection.h.

## Ptr

using pcl::registration::CorrespondenceRejector::Ptr = shared_ptr<CorrespondenceRejector>

Definition at line 56 of file correspondence_rejection.h.

## Constructor & Destructor Documentation

## CorrespondenceRejector()

pcl::registration::CorrespondenceRejector::CorrespondenceRejector | ( |  | ) |

default

Empty constructor.

## ~CorrespondenceRejector()

virtual pcl::registration::CorrespondenceRejector::~CorrespondenceRejector | ( |  | ) |

virtual default

Empty destructor.

## Member Function Documentation

## applyRejection()

virtual void pcl::registration::CorrespondenceRejector::applyRejection | ( | Correspondences & | correspondences | ) |

protected pure virtual

Abstract rejection method.

Implemented in pcl::registration::CorrespondenceRejectionOrganizedBoundary, pcl::registration::CorrespondenceRejectorDistance, pcl::registration::CorrespondenceRejectorFeatures, pcl::registration::CorrespondenceRejectorMedianDistance, pcl::registration::CorrespondenceRejectorOneToOne, pcl::registration::CorrespondenceRejectorPoly< SourceT, TargetT >, pcl::registration::CorrespondenceRejectorPoly< PointSource, PointTarget >, pcl::registration::CorrespondenceRejectorSampleConsensus2D< PointT >, pcl::registration::CorrespondenceRejectorSampleConsensus< PointT >, pcl::registration::CorrespondenceRejectorSurfaceNormal, pcl::registration::CorrespondenceRejectorTrimmed, and pcl::registration::CorrespondenceRejectorVarTrimmed.

Referenced by getCorrespondences().

## getClassName()

const std::string & pcl::registration::CorrespondenceRejector::getClassName | ( |  | ) | const

inline

Get a string representation of the name of this class.

Definition at line 131 of file correspondence_rejection.h.

References rejection_name_.

Referenced by getRejectedQueryIndices(), setSourceNormals(), setSourcePoints(), setTargetNormals(), and setTargetPoints().

## getCorrespondences()

void pcl::registration::CorrespondenceRejector::getCorrespondences | ( | pcl::Correspondences & | correspondences | ) |

inline

Run correspondence rejection.

Parameters

  [out] | correspondences | Vector of correspondences that have not been rejected.

Definition at line 87 of file correspondence_rejection.h.

References applyRejection(), and input_correspondences_.

## getInputCorrespondences()

CorrespondencesConstPtr pcl::registration::CorrespondenceRejector::getInputCorrespondences | ( |  | ) |

inline

Get a pointer to the vector of the input correspondences.

Returns
  correspondences the const shared pointer to a correspondence vector

Definition at line 78 of file correspondence_rejection.h.

References input_correspondences_.

## getRejectedQueryIndices()

void pcl::registration::CorrespondenceRejector::getRejectedQueryIndices | ( | const pcl::Correspondences & | correspondences,
|  | pcl::Indices & | indices )

inline

Determine the indices of query points of correspondences that have been rejected, i.e., the difference between the input correspondences (set via setInputCorrespondences) and the given correspondence vector.

Parameters

  [in] | correspondences | Vector of correspondences after rejection
  [out] | indices | Vector of query point indices of those correspondences that have been rejected.

Definition at line 116 of file correspondence_rejection.h.

References getClassName(), pcl::getRejectedQueryIndices(), and input_correspondences_.

## getRemainingCorrespondences()

virtual void pcl::registration::CorrespondenceRejector::getRemainingCorrespondences | ( | const pcl::Correspondences & | original_correspondences,
|  | pcl::Correspondences & | remaining_correspondences )

inline pure virtual

Get a list of valid correspondences after rejection from the original set of correspondences.

Pure virtual. Compared to getCorrespondences this function is stateless, i.e., input correspondences do not need to be provided beforehand, but are directly provided in the function call.

Parameters

  [in] | original_correspondences | the set of initial correspondences given
  [out] | remaining_correspondences | the resultant filtered set of remaining correspondences

Implemented in pcl::registration::CorrespondenceRejectionOrganizedBoundary, pcl::registration::CorrespondenceRejectorDistance, pcl::registration::CorrespondenceRejectorFeatures, pcl::registration::CorrespondenceRejectorMedianDistance, pcl::registration::CorrespondenceRejectorOneToOne, pcl::registration::CorrespondenceRejectorPoly< SourceT, TargetT >, pcl::registration::CorrespondenceRejectorPoly< PointSource, PointTarget >, pcl::registration::CorrespondenceRejectorSampleConsensus2D< PointT >, pcl::registration::CorrespondenceRejectorSampleConsensus< PointT >, pcl::registration::CorrespondenceRejectorSurfaceNormal, pcl::registration::CorrespondenceRejectorTrimmed, and pcl::registration::CorrespondenceRejectorVarTrimmed.

## requiresSourceNormals()

virtual bool pcl::registration::CorrespondenceRejector::requiresSourceNormals | ( |  | ) | const

inline virtual

See if this rejector requires source normals.

Reimplemented in pcl::registration::CorrespondenceRejectorSurfaceNormal.

Definition at line 154 of file correspondence_rejection.h.

## requiresSourcePoints()

virtual bool pcl::registration::CorrespondenceRejector::requiresSourcePoints | ( |  | ) | const

inline virtual

See if this rejector requires source points.

Reimplemented in pcl::registration::CorrespondenceRejectionOrganizedBoundary, pcl::registration::CorrespondenceRejectorDistance, pcl::registration::CorrespondenceRejectorMedianDistance, pcl::registration::CorrespondenceRejectorPoly< SourceT, TargetT >, pcl::registration::CorrespondenceRejectorPoly< PointSource, PointTarget >, pcl::registration::CorrespondenceRejectorSampleConsensus< PointT >, pcl::registration::CorrespondenceRejectorSurfaceNormal, and pcl::registration::CorrespondenceRejectorVarTrimmed.

Definition at line 138 of file correspondence_rejection.h.

## requiresTargetNormals()

virtual bool pcl::registration::CorrespondenceRejector::requiresTargetNormals | ( |  | ) | const

inline virtual

See if this rejector requires target normals.

Reimplemented in pcl::registration::CorrespondenceRejectorSurfaceNormal.

Definition at line 185 of file correspondence_rejection.h.

## requiresTargetPoints()

virtual bool pcl::registration::CorrespondenceRejector::requiresTargetPoints | ( |  | ) | const

inline virtual

See if this rejector requires a target cloud.

Reimplemented in pcl::registration::CorrespondenceRejectionOrganizedBoundary, pcl::registration::CorrespondenceRejectorDistance, pcl::registration::CorrespondenceRejectorMedianDistance, pcl::registration::CorrespondenceRejectorPoly< SourceT, TargetT >, pcl::registration::CorrespondenceRejectorPoly< PointSource, PointTarget >, pcl::registration::CorrespondenceRejectorSampleConsensus< PointT >, pcl::registration::CorrespondenceRejectorSurfaceNormal, and pcl::registration::CorrespondenceRejectorVarTrimmed.

Definition at line 169 of file correspondence_rejection.h.

## setInputCorrespondences()

virtual void pcl::registration::CorrespondenceRejector::setInputCorrespondences | ( | const CorrespondencesConstPtr & | correspondences | ) |

inline virtual

Provide a pointer to the vector of the input correspondences.

Parameters

  [in] | correspondences | the const shared pointer to a correspondence vector

Definition at line 69 of file correspondence_rejection.h.

References input_correspondences_.

## setSourceNormals()

virtual void pcl::registration::CorrespondenceRejector::setSourceNormals | ( | pcl::PCLPointCloud2::ConstPtr |  | ) |

inline virtual

Abstract method for setting the source normals.

Reimplemented in pcl::registration::CorrespondenceRejectorSurfaceNormal.

Definition at line 161 of file correspondence_rejection.h.

References getClassName().

## setSourcePoints()

virtual void pcl::registration::CorrespondenceRejector::setSourcePoints | ( | pcl::PCLPointCloud2::ConstPtr |  | ) |

inline virtual

Abstract method for setting the source cloud.

Reimplemented in pcl::registration::CorrespondenceRejectionOrganizedBoundary, pcl::registration::CorrespondenceRejectorDistance, pcl::registration::CorrespondenceRejectorMedianDistance, pcl::registration::CorrespondenceRejectorPoly< SourceT, TargetT >, pcl::registration::CorrespondenceRejectorPoly< PointSource, PointTarget >, pcl::registration::CorrespondenceRejectorSampleConsensus< PointT >, pcl::registration::CorrespondenceRejectorSurfaceNormal, and pcl::registration::CorrespondenceRejectorVarTrimmed.

Definition at line 145 of file correspondence_rejection.h.

References getClassName().

## setTargetNormals()

virtual void pcl::registration::CorrespondenceRejector::setTargetNormals | ( | pcl::PCLPointCloud2::ConstPtr |  | ) |

inline virtual

Abstract method for setting the target normals.

Reimplemented in pcl::registration::CorrespondenceRejectorSurfaceNormal.

Definition at line 192 of file correspondence_rejection.h.

References getClassName().

## setTargetPoints()

virtual void pcl::registration::CorrespondenceRejector::setTargetPoints | ( | pcl::PCLPointCloud2::ConstPtr |  | ) |

inline virtual

Abstract method for setting the target cloud.

Reimplemented in pcl::registration::CorrespondenceRejectionOrganizedBoundary, pcl::registration::CorrespondenceRejectorDistance, pcl::registration::CorrespondenceRejectorMedianDistance, pcl::registration::CorrespondenceRejectorPoly< SourceT, TargetT >, pcl::registration::CorrespondenceRejectorPoly< PointSource, PointTarget >, pcl::registration::CorrespondenceRejectorSampleConsensus< PointT >, pcl::registration::CorrespondenceRejectorSurfaceNormal, and pcl::registration::CorrespondenceRejectorVarTrimmed.

Definition at line 176 of file correspondence_rejection.h.

References getClassName().

## Member Data Documentation

## input_correspondences_

CorrespondencesConstPtr pcl::registration::CorrespondenceRejector::input_correspondences_

protected

The input correspondences.

Definition at line 204 of file correspondence_rejection.h.

Referenced by pcl::registration::CorrespondenceRejectionOrganizedBoundary::applyRejection(), getCorrespondences(), getInputCorrespondences(), getRejectedQueryIndices(), and setInputCorrespondences().

## rejection_name_

std::string pcl::registration::CorrespondenceRejector::rejection_name_ {}

protected

The name of the rejection method.

Definition at line 201 of file correspondence_rejection.h.

Referenced by getClassName().

The documentation for this class was generated from the following file:

- pcl/registration/correspondence_rejection.h